/*
	$Date: 1996/11/02 18:33:46 $
	$Revision: 1.1 $
*/
#include <stdio.h>

ishiragana(unsigned char *h)
{
	return *h == 0xa4;
}
isplainhiragana(unsigned char *h)
{
	static unsigned char cat[] = "ĤƤȤʤˤ̤ͤΤϤҤդؤۤޤߤ䤤椨𤦤";
	unsigned char *s;
	for(s=cat;*s;s+=2){
		if(strncmp(h,s,2)==0) break;
	}
	return (*s ? 1 : 0);
}
havedakuten(unsigned char *h)
{
	static unsigned char cat[] = "ĤƤȤϤҤդؤ";
	unsigned char *s;
	for(s=cat;*s;s+=2){
		if(strncmp(h,s,2)==0) break;
	}
	return (*s ? 1 : 0);
}
havehandakuten(unsigned char *h)
{
	static unsigned char cat[] = "ϤҤդؤ";
	unsigned char *s;
	for(s=cat;*s;s+=2){
		if(strncmp(h,s,2)==0) break;
	}
	return (*s ? 1 : 0);
}
havesmall(unsigned char *h)
{
	static unsigned char cat[] = "Ĥ";
	unsigned char *s;
	for(s=cat;*s;s+=2){
		if(strncmp(h,s,2)==0) break;
	}
	return (*s ? 1 : 0);
}

unsigned char *
htok(unsigned char *h){
	unsigned char *s;
	static unsigned char buf[1000];
	strcpy(buf,h);
	for(s=buf;*s;s+=2){
		if(ishiragana(s)) (*s)++;
	}
	return buf;
}

/*
	/ȾѴ
*/
static unsigned char *zstr = 
	"£ãģţƣǣȣɣʣˣ̣ͣΣϣУѣңӣԣգ֣ףأ٣"
	""
	"ɡǡʡˡܡݡ䡩Ρϡ"
	"Сáѡ";
static unsigned char *hstr =
	"ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz"
	"!\"#$%&'()*+,-./:;<=>?[\\]^_{|}~0123456789 ";

havehankaku(unsigned char *s)
{
	unsigned char *z;
	for(z=zstr;*z;z+=2){
		if(strncmp(z,s,2)==0) return 1;
	}
	return 0;
}

static 
ztoh1(unsigned char *s)
{
	int i;	
	static char buf[2];
	for(i=0;zstr[i*2];i++){
		if(strncmp(zstr+i*2,s,2)==0){
			return hstr[i];
		}
	}
	return NULL;
}

unsigned char*
ztoh(unsigned char *s)
{
	static unsigned char buf[1000];
	unsigned char *p;
	p = buf;
	while(*s){
		if(*s >= 0x80){
			if(havehankaku(s)){
				*p++ = ztoh1(s);
			}
			else {
				strncpy(p,s,2);
				p += 2;
			}
			s += 2;
		}
		else {
			*p++ = *s++;
		}
	}
	*p = '\0';
	return buf;
}
/*
	ʸ/ʸѴ
*/

static unsigned char *upperzenkakustr = 
	"£ãģţƣǣȣɣʣˣ̣ͣΣϣУѣңӣԣգ֣ףأ٣";
static unsigned char *lowerzenkakustr = 
	"";

unsigned char *
lowercase(unsigned char *s)
{
	static unsigned char buf[1000];
	unsigned char *p;
	int i;
	p = buf;
	while(*s){
		if(*s >= 0x80){
			strncpy(p,s,2);
			for(i=0;upperzenkakustr[i];i+=2){
				if(strncmp(upperzenkakustr+i,s,2)==0){
					strncpy(p,lowerzenkakustr+i,2);
					break;
				}
			}
			p += 2;
			s += 2;
		}
		else {
			if(isupper(*s)){
				*p++ = tolower(*s++);
			}
			else {
				*p++ = *s++;
			}
		}
	}
	*p = '\0';
	return buf;
}

#ifdef TEST
main()
{
	printf("%s\n",ztoh("ȾhankakuѵʡڣţΣˣˣդκäʸ"));
	printf("%s\n",lowercase("ȾHANKAKUhankakuѵʡڣţΣˣˣդκäʸ"));
}
	
#endif


